#if !defined(RT_APP_H)
#define RT_APP_H
//-----------------------------------------------------------------------------
// app.h
//
// Code factored out from multiple D3D sample apps based on CD3DApplication
// and D3DFrame.
//

namespace rt
{

//-----------------------------------------------------------------------------
// check_menu
//
// Makes a menu item's check mark reflect the value of a bool.
//
inline void
check_menu(HMENU menu, UINT item, bool value)
{
    ::CheckMenuItem(menu, item, value ? MF_CHECKED : MF_UNCHECKED);
}

//-----------------------------------------------------------------------------
// pauser
//
// Pauses a CD3DApplication in it's c'tor, resumes in its d'tor
//
class pauser
{
public:
    pauser(CD3DApplication &app) : m_app(app)
    {
        m_app.Pause(true);
    }
    ~pauser()
    {
        m_app.Pause(false);
    }
private:
    CD3DApplication &m_app;
};

//-----------------------------------------------------------------------------
// accum_minmax
//
// Given a floating point value, accumulate it into a min/max pair.
//
inline void
accum_minmax(float val, float &min, float &max)
{
    if (val < min)
    {
        min = val;
    }
    else if (val > max)
    {
        max = val;
    }
}


}; // ::rt

#endif
